% algorithme de Viterbi

function [valeur,ante,dens] = Viterbi(X,A,p,m,sigma2,K,T)

% densite d'emission

dens = ones(T,K); 
dens = exp(-0.5*(X'*ones(1,K)-ones(T,1)*m).^2./(ones(T,1)*sigma2))./...
    sqrt(ones(T,1)*sigma2);

% fonction valeur

valeur = ones(T,K);
valeur(1,:) = p.*dens(1,:);
for t=2:T
    [c,I] = max((ones(K,1)*valeur(t-1,:)).*A,[],2);
    valeur(t,:) = c'.*dens(t,:);
    valeur(t,:) = valeur(t,:)/max(valeur(t,:));
    ante(t,:) = I;
end