% modele de Markov cache

function [X,Y] = gen(A,p,m,sigma2,T)
sigma = sqrt(sigma2);
Y(1) = multinomiale(p);
for t=2:T
    q = A(Y(t-1),:);
    Y(t) = multinomiale(q);
end
w = randn(1,T);
for t=1:T
    moyenne = m(Y(t));
    ecart_type = sigma(Y(t));
    X(t) = moyenne+ecart_type*w(t);
end